## simgrid 3.10

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
### Need to set rc ccompiler before enable language
if(WIN32)
  SET(CMAKE_RC_COMPILER "windres")
endif()
project(SimGrid C)
if (enable_gtnets OR enable_ns3)
  enable_language(CXX)
endif()
if (NOT DEFINED enable_smpi OR enable_smpi) # smpi is enabled by default
  # Call enable_language(Fortran) in order to load the build rules for
  # this language, needed by teshsuite/smpi/mpich-test/.  Use
  # CMAKE_FORCE_Fortran_COMPILER to bypass checks for a working
  # compiler (smpiff don't exist at configure time).
  include(CMakeForceCompiler)
  if(NOT COMMAND CMAKE_FORCE_Fortran_COMPILER)
    MACRO(CMAKE_FORCE_Fortran_COMPILER compiler id)
      SET(CMAKE_Fortran_COMPILER "${compiler}")
      SET(CMAKE_Fortran_COMPILER_ID_RUN TRUE)
      SET(CMAKE_Fortran_COMPILER_ID ${id})
      SET(CMAKE_Fortran_COMPILER_WORKS TRUE)
      SET(CMAKE_Fortran_COMPILER_FORCED TRUE)

      # Set old compiler id variables.
      IF("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
        SET(CMAKE_COMPILER_IS_GNUG77 1)
      ENDIF("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
    ENDMACRO(CMAKE_FORCE_Fortran_COMPILER)
  endif()
  CMAKE_FORCE_Fortran_COMPILER(smpiff smpiff)
  enable_language(Fortran OPTIONAL)
endif()

set(CMAKE_C_FLAGS "" CACHE TYPE INTERNAL FORCE)
set(CMAKE_CXX_FLAGS "" CACHE TYPE INTERNAL FORCE)
set(CMAKE_EXE_LINKER_FLAGS "" CACHE TYPE INTERNAL FORCE)
set(CMAKE_C_LINK_FLAGS "" CACHE TYPE INTERNAL FORCE)
set(CMAKE_Fortran_FLAGS "" CACHE TYPE INTERNAL FORCE)
set(CMAKE_Fortran_LINK_FLAGS "" CACHE TYPE INTERNAL FORCE)
## Mapping version number -> version name
# 3.5.99 -> alpha1 (oops)
# 3.5.9{1,2} -> beta{1,2}
# 3.5.9{3,4,5} -> rc{1,2,3}
# 3.6.{0,1,2} -> release 3.6, 3.6.1, 3.6.2
# 3.7.{0,1} -> release 3.7, 3.7.1
# 3.8.{0,1} -> release 3.8, 3.8.1
# 3.9.0 -> release 3.9
# 3.9.90 -> release 3.10pre1
# 3.10.0 -> release 3.10

set(SIMGRID_VERSION_MAJOR "3")
set(SIMGRID_VERSION_MINOR "10")
set(SIMGRID_VERSION_PATCH "0")
set(SIMGRID_VERSION_EXTRA "") # Extra words to add to version string (e.g. -rc1)

set(SIMGRID_VERSION_DATE  "2013") # Year for copyright information

if(${SIMGRID_VERSION_PATCH} EQUAL "0")
  set(release_version "${SIMGRID_VERSION_MAJOR}.${SIMGRID_VERSION_MINOR}")
else()
  set(release_version "${SIMGRID_VERSION_MAJOR}.${SIMGRID_VERSION_MINOR}.${SIMGRID_VERSION_PATCH}")
endif()

set(SIMGRID_VERSION_STRING
  "SimGrid version ${release_version}${SIMGRID_VERSION_EXTRA}\\nCopyright (c) ${SIMGRID_VERSION_DATE}. The Simgrid Team.")

set(libsimgrid_version "${release_version}")
set(libsimgrid-java_version "${release_version}")
set(GCC_NEED_VERSION "4.0")
set(APPLE_NEED_GCC_VERSION "4.6")

### SET THE LIBRARY EXTENSION AND GCC VERSION
if(APPLE) #MAC
  set(LIB_EXE "dylib")
else()
  if(WIN32) #WINDOWS
    set(LIB_EXE "a")
    set(BIN_EXE ".exe")
  else() #UNIX
    set(LIB_EXE "so")
  endif()
endif()

if(${CMAKE_C_COMPILER_ID} STREQUAL "GNU")
  exec_program("${CMAKE_C_COMPILER} --version" OUTPUT_VARIABLE "COMPILER_C_VERSION")
  exec_program("${CMAKE_CXX_COMPILER} --version" OUTPUT_VARIABLE "COMPILER_CXX_VERSION")
  string(REGEX MATCH "[0-9].[0-9].[0-9]" COMPILER_C_VERSION "${COMPILER_C_VERSION}")
  string(REGEX MATCH "[0-9].[0-9].[0-9]" COMPILER_CXX_VERSION "${COMPILER_CXX_VERSION}")

  string(REGEX MATCH "^[0-9].[0-9]" COMPILER_C_VERSION_MAJOR_MINOR "${COMPILER_C_VERSION}")
  string(REPLACE "${COMPILER_C_VERSION_MAJOR_MINOR}." "" COMPILER_C_VERSION_PATCH "${COMPILER_C_VERSION}")

  if(${GCC_NEED_VERSION} GREATER  COMPILER_C_VERSION_MAJOR_MINOR)
    message(FATAL_ERROR "Gcc must be to version ${GCC_NEED_VERSION} current version ${COMPILER_C_VERSION_MAJOR_MINOR}")
  endif()
endif()

string(REGEX MATCH "cl.exe" VBC "${CMAKE_C_COMPILER}")
if(VBC)
  message(FATAL_ERROR "VB is not yet supported by Simgrid.")
endif()

### Find programs and paths
FIND_PROGRAM(GCOV_PATH gcov)
include(FindPerl)
if(NOT PERL_EXECUTABLE)
  message(FATAL_ERROR "-- SimGrid cannot be compiled without Perl installed -- sorry. Bailling out.")
endif()

### Set some variables for Cmake
SET(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

set(INCLUDES
  ${CMAKE_HOME_DIRECTORY}
  ${CMAKE_HOME_DIRECTORY}/include
  ${CMAKE_HOME_DIRECTORY}/src
  ${CMAKE_HOME_DIRECTORY}/src/include
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/include
  ${CMAKE_BINARY_DIR}/src
  )

if(WIN32)
  set(INCLUDES ${INCLUDES} ${CMAKE_HOME_DIRECTORY}/include/xbt ${CMAKE_HOME_DIRECTORY}/src/xbt) #for win32_ucontext.[ch]
endif()
set(CMAKE_SOURCE_DIR ${PROJECT_SOURCE_DIRECTORY})

if(NOT CMAKE_CROSSCOMPILING AND EXISTS /usr/include/)
  set(INCLUDES ${INCLUDES} /usr/include/)
endif()

### Check 32bits or 64bits
INCLUDE (CheckTypeSize)
CHECK_TYPE_SIZE("void*" SIZEOF_VOIDSTAR)
IF(SIZEOF_VOIDSTAR EQUAL 4)
  SET(ARCH_32_BITS 1)
ELSE()
  SET(ARCH_32_BITS 0)
ENDIF()

if(WIN32)

  #Need env INCLUDE
  set(CMAKE_INCLUDE_WIN "${CMAKE_C_COMPILER}")
  set(CMAKE_LIB_WIN "${CMAKE_C_COMPILER}")
  string(REGEX REPLACE "/bin/gcc.*" "/include"  CMAKE_INCLUDE_WIN "${CMAKE_INCLUDE_WIN}")
  string(REGEX REPLACE "/bin/gcc.*" "/lib"  CMAKE_LIB_WIN "${CMAKE_LIB_WIN}")
  set(INCLUDES ${INCLUDES} ${CMAKE_INCLUDE_WIN})

  if(CMAKE_COMPILER_IS_GNUCC)
    set(__GNUC__ 1)
    exec_program("${CMAKE_C_COMPILER} --version" OUTPUT_VARIABLE "COMPILER_C_VERSION")
    string(REGEX MATCH "[0-9].[0-9].[0-9]" COMPILER_C_VERSION "${COMPILER_C_VERSION}")
    string(REGEX MATCH "^[0-9]" COMPILER_C_MAJOR_VERSION "${COMPILER_C_VERSION}")
    string(REGEX MATCH "^[0-9].[0-9]" COMPILER_C_MINOR_VERSION "${COMPILER_C_VERSION}")
    string(REGEX REPLACE "^${COMPILER_C_MAJOR_VERSION}." "" COMPILER_C_MINOR_VERSION "${COMPILER_C_MINOR_VERSION}")
    if(COMPILER_C_MAJOR_VERSION)
      # set(__GNUC__ ${COMPILER_C_MAJOR_VERSION})
    endif()
    if(COMPILER_C_MINOR_VERSION)
      # set(__GNUC_MINOR__ ${COMPILER_C_MINOR_VERSION})
    endif()
    set(MSVC 0)
    set(BORLAND 0)
  else()
    message(FATAL_ERROR "Please use MinGW to compile SimGrid!")
  endif()

  if(ARCH_32_BITS)	### Arch 32bits
    set(_WIN32 1)
  else()	### Arch 64bits
    set(_WIN64 1)
  endif()

  set(NSIS_WIN_VERSION $ENV{PROCESSOR_ARCHITEW6432})
  if(NSIS_WIN_VERSION MATCHES "")
    set(NSIS_WIN_VERSION $ENV{PROCESSOR_ARCHITECTURE})
  endif()
  string(TOLOWER ${NSIS_WIN_VERSION} NSIS_WIN_VERSION)

  set(_XBT_WIN32 1)

  message(STATUS "C_COMPILER			${CMAKE_C_COMPILER} ${COMPILER_C_VERSION}")
  message(STATUS "CXX_COMPILER			${CMAKE_CXX_COMPILER} ${COMPILER_CXX_VERSION}")
  message(STATUS "CMAKE_RC_COMPILER		${CMAKE_RC_COMPILER}")
  message(STATUS "INCLUDE			${CMAKE_INCLUDE_WIN}")
  message(STATUS "LIB				${CMAKE_LIB_WIN}")
  message(STATUS "MAKE_PROGRAM			${CMAKE_MAKE_PROGRAM}")
  message(STATUS "CMAKE_BUILD_TOOL		${CMAKE_BUILD_TOOL}")
  message(STATUS "LINKER			${CMAKE_LINKER}")
  message(STATUS "CMAKE_GENERATOR		${CMAKE_GENERATOR}")
  message(STATUS "BORLAND			${BORLAND}")
  message(STATUS "VISUALC			${MSVC}")
  message(STATUS "GNUC				${CMAKE_COMPILER_IS_GNUCC}")

endif()

include_directories(${INCLUDES})

### Setup Options
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/Option.cmake)

### Make the *.h files with *.h.in files
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/CompleteInFiles.cmake)

### Define source packages for Libs
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/DefinePackages.cmake)

### Build some Maintainer files
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/MaintainerMode.cmake)
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/UnitTesting.cmake)

### Setup gcc flags
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/Flags.cmake)

### Make Libs
if(NOT WIN32)
  include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/MakeLib.cmake)
else()
  include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/MakeLibWin.cmake)
endif()

### Make Exes
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/MakeExe.cmake)

### Make tests
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/AddTests.cmake)
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/CTestConfig.cmake)

### Setup the distrib
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/Distrib.cmake)

### Pipol compilation
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/Pipol.cmake)

### Build the doc
if(NOT WIN32)
  include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/GenerateDoc.cmake)
else()
  include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/GenerateDocWin.cmake)
endif()

### Print ARGS
include(${CMAKE_HOME_DIRECTORY}/buildtools/Cmake/PrintArgs.cmake)

INCLUDE(Dart)

=== Makefile ===
#THIS Makefile should be erase by Cmake when use command "cmake."

all : 
	@echo "THIS COMMAND IS NOT AVAILABLE!"
	@echo "Since v3.4 we use Cmake. Now use:"
	@echo "\tcmake -DCMAKE_INSTALL_PREFIX=<where_you_want> .\n\tmake\n\tmake install"

clean : all

=== tools/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(bin_files
  ${bin_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/fix-paje-trace.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/indent
  ${CMAKE_CURRENT_SOURCE_DIR}/platf_route_rulebased2full.py
  ${CMAKE_CURRENT_SOURCE_DIR}/sg_unit_extractor.pl
  ${CMAKE_CURRENT_SOURCE_DIR}/sg_xml_unit_converter.py
  ${CMAKE_CURRENT_SOURCE_DIR}/simgrid_update_xml.pl
  ${CMAKE_CURRENT_SOURCE_DIR}/xbt_exception_checker
  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen/fig2dev_postprocessor.pl
  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen/index_create.pl
  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen/xbt_log_extract_hierarchy.pl
  ${CMAKE_CURRENT_SOURCE_DIR}/MSG_visualization/colorize.pl
  ${CMAKE_CURRENT_SOURCE_DIR}/MSG_visualization/trace2fig.pl
  PARENT_SCOPE
  )

set(txt_files
  ${txt_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/simgrid.supp
  ${CMAKE_CURRENT_SOURCE_DIR}/simgrid2vite.sed
  PARENT_SCOPE
  )

=== doc/HelloWorld/CMakeLists.txt ===
### This is a template for building targets with simgrid
cmake_minimum_required(VERSION 2.8)

### Need to set rc ccompiler before enable language
if(WIN32)
  SET(CMAKE_RC_COMPILER "windres")
  set(LIBRARIES_DEP simgrid ws2_32 pthread)
else()
  set(LIBRARIES_DEP simgrid pthread)
endif()

project(MY_SIMGRID_PROJECT C)

set(CMAKE_C_FLAGS "" CACHE TYPE INTERNAL FORCE)
set(CMAKE_EXE_LINKER_FLAGS "" CACHE TYPE INTERNAL FORCE)

###############################
# Test the build dependencies #
###############################
message(STATUS "Looking for lib Simgrid")
if("$ENV{SIMGRID_ROOT}" STREQUAL "")
  message(STATUS "Looking for lib Simgrid - Not found")
  message(FATAL_ERROR "Simgrid not found, reinstall it or set SIMGRID_ROOT")
else()
  link_directories($ENV{SIMGRID_ROOT}/lib)
  include_directories($ENV{SIMGRID_ROOT}/include)
  include_directories($ENV{SIMGRID_ROOT}/src)
  include_directories($ENV{SIMGRID_ROOT}/src/include)
  message(STATUS "Looking for lib Simgrid - found")
endif()

################
# FIND TARGETS #
################
file(GLOB SOURCE_FILE
  RELATIVE ${CMAKE_HOME_DIRECTORY}/
  "*.c"
  )
string(REPLACE ".c" "" TARGET_NAME ${SOURCE_FILE})

foreach(target "${TARGET_NAME}")
  add_executable(${target} "${target}.c")
  message(STATUS "source_file: ${target}.c")
  message(STATUS "target name: ${target}.exe")
  # Any targets need to be linked with libraries
  target_link_libraries(${target} ${LIBRARIES_DEP})
endforeach(target ${SOURCE_FILE})

=== examples/java/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(tesh_files
  ${tesh_files}
  PARENT_SCOPE
  )
set(xml_files
  ${xml_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/platform.xml
  PARENT_SCOPE
  )
set(examples_src
  ${examples_src}
  PARENT_SCOPE
  )
set(bin_files
  ${bin_files}
  PARENT_SCOPE
  )
set(txt_files
  ${txt_files}
  PARENT_SCOPE
  )

=== examples/msg/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(tesh_files
  ${tesh_files}
  PARENT_SCOPE
  )
set(xml_files
  ${xml_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/msg_platform.xml
  ${CMAKE_CURRENT_SOURCE_DIR}/small_platform_with_failures.xml
  ${CMAKE_CURRENT_SOURCE_DIR}/small_platform_with_routers.xml
  ${CMAKE_CURRENT_SOURCE_DIR}/small_platform.xml
  PARENT_SCOPE
  )
set(examples_src
  ${examples_src}
  PARENT_SCOPE
  )
set(bin_files
  ${bin_files}
  PARENT_SCOPE
  )
set(txt_files
  ${txt_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/bourassa_state.trace
  ${CMAKE_CURRENT_SOURCE_DIR}/fafard_state.trace
  ${CMAKE_CURRENT_SOURCE_DIR}/ginette_state.trace
  ${CMAKE_CURRENT_SOURCE_DIR}/jupiter_state.trace
  ${CMAKE_CURRENT_SOURCE_DIR}/link3_state.trace
  ${CMAKE_CURRENT_SOURCE_DIR}/link4_state.trace
  ${CMAKE_CURRENT_SOURCE_DIR}/link5_state.trace
  ${CMAKE_CURRENT_SOURCE_DIR}/README
  PARENT_SCOPE
  )

=== examples/simdag/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(EXECUTABLE_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}")

add_executable(ex_sd_test sd_test.c)
add_executable(sd_test2 sd_test2.c)
add_executable(sd_fail sd_fail.c)
add_executable(sd_avail sd_avail.c)
add_executable(sd_typed_tasks_test sd_typed_tasks_test.c)
add_executable(sd_comm_throttling sd_comm_throttling.c)
add_executable(sd_seq_access sd_seq_access.c)

if (HAVE_TRACING)
  add_executable(simdag_tracing simdag_trace.c)
endif()

### Add definitions for compile
if(NOT WIN32)
  target_link_libraries(ex_sd_test simgrid pthread )
  target_link_libraries(sd_test2 simgrid pthread )
  target_link_libraries(sd_fail simgrid pthread )
  target_link_libraries(sd_avail simgrid pthread )
  target_link_libraries(sd_typed_tasks_test simgrid pthread )
  target_link_libraries(sd_comm_throttling simgrid pthread )
  target_link_libraries(sd_seq_access simgrid pthread )
  if (HAVE_TRACING)
  target_link_libraries(simdag_tracing simgrid pthread )
  endif()

  add_custom_command(TARGET ex_sd_test
    POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/ex_sd_test ${CMAKE_CURRENT_BINARY_DIR}/sd_test
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/"
    )
  get_directory_property(extra_clean_files ADDITIONAL_MAKE_CLEAN_FILES)
  set_directory_properties(
    PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${extra_clean_files};${CMAKE_CURRENT_BINARY_DIR}/sd_test")

else()
  target_link_libraries(ex_sd_test simgrid)
  target_link_libraries(sd_test2 simgrid)
  target_link_libraries(sd_fail simgrid)
  target_link_libraries(sd_avail simgrid)
  target_link_libraries(sd_typed_tasks_test simgrid)
  target_link_libraries(sd_comm_throttling simgrid)
  target_link_libraries(sd_seq_access simgrid)
  if (HAVE_TRACING)
    target_link_libraries(simdag_tracing simgrid)
  endif()
  
  add_custom_command(TARGET ex_sd_test
    POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/ex_sd_test.exe ${CMAKE_CURRENT_BINARY_DIR}/sd_test.exe
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/"
    )
  get_directory_property(extra_clean_files ADDITIONAL_MAKE_CLEAN_FILES)
  set_directory_properties(
    PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${extra_clean_files};${CMAKE_CURRENT_BINARY_DIR}/sd_test.exe")
endif()

set(tesh_files
  ${tesh_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/test_simdag.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/test_simdag2.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/test_simdag_comm_throttling.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/test_simdag_seq_access.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/test_simdag_tracing.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/test_simdag_typed_tasks.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/test_simdag_avail.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/test_simdag_fail.tesh
  PARENT_SCOPE
  )
set(xml_files
  ${xml_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/2clusters.xml
  ${CMAKE_CURRENT_SOURCE_DIR}/two_hosts.xml
  ${CMAKE_CURRENT_SOURCE_DIR}/faulty_host.xml
  PARENT_SCOPE
  )
set(examples_src
  ${examples_src}
  ${CMAKE_CURRENT_SOURCE_DIR}/sd_avail.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sd_comm_throttling.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sd_fail.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sd_seq_access.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sd_test.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sd_test2.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sd_typed_tasks_test.c
  ${CMAKE_CURRENT_SOURCE_DIR}/simdag_trace.c
  PARENT_SCOPE
  )
set(bin_files
  ${bin_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/platform_script.lua
  ${CMAKE_CURRENT_SOURCE_DIR}/test_simdag.in
  PARENT_SCOPE
  )
set(txt_files
  ${txt_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/faulty_host.trace
  ${CMAKE_CURRENT_SOURCE_DIR}/jupiter_power.trace
  ${CMAKE_CURRENT_SOURCE_DIR}/link1_avail.trace
  PARENT_SCOPE
  )

=== examples/smpi/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

if(enable_smpi)
  if(WIN32)
    set(CMAKE_C_FLAGS "-include ${CMAKE_HOME_DIRECTORY}/include/smpi/smpi_main.h")
  else()
    set(CMAKE_C_COMPILER "${CMAKE_BINARY_DIR}/smpi_script/bin/smpicc")
  endif()

  set(EXECUTABLE_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}")

  include_directories("${CMAKE_HOME_DIRECTORY}/include/smpi")
  file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/mc/")


  add_executable(bcbench bcbench.c)
  add_executable(mvmul mvmul.c)
  add_executable(smpi_traced tracing/smpi_traced.c)
  add_executable(smpi_traced_simple tracing/smpi_traced_simple.c)
  add_executable(smpi_replay replay/replay.c)
  
  if(HAVE_MC)
    add_executable(mc/bugged1 mc/bugged1.c)
    add_executable(mc/bugged2 mc/bugged2.c)
    add_executable(mc/bugged1_liveness mc/bugged1_liveness.c)
  
    target_link_libraries(mc/bugged1 simgrid)
    target_link_libraries(mc/bugged2 simgrid)
    target_link_libraries(mc/bugged1_liveness simgrid)
  endif()
  
  target_link_libraries(bcbench simgrid)
  target_link_libraries(mvmul simgrid)
  target_link_libraries(smpi_traced simgrid)
  target_link_libraries(smpi_traced_simple simgrid)
  target_link_libraries(smpi_replay simgrid)

endif()

set(tesh_files
  ${tesh_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/tracing/smpi_traced.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/smpi_replay.tesh
  PARENT_SCOPE
  )
set(xml_files
  ${xml_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/replay_platform.xml
  PARENT_SCOPE
  )
set(examples_src
  ${examples_src}
  ${CMAKE_CURRENT_SOURCE_DIR}/mvmul.c
  ${CMAKE_CURRENT_SOURCE_DIR}/bcbench.c
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/replay.c
  ${CMAKE_CURRENT_SOURCE_DIR}/tracing/smpi_traced.c
  ${CMAKE_CURRENT_SOURCE_DIR}/tracing/smpi_traced_simple.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mc/bugged2.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mc/bugged1.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mc/bugged1_liveness.c
  PARENT_SCOPE
  )
set(bin_files
  ${bin_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/hostfile
  ${CMAKE_CURRENT_SOURCE_DIR}/mc/promela_bugged1_liveness
  ${CMAKE_CURRENT_SOURCE_DIR}/mc/hostfile_bugged1_liveness
  ${CMAKE_CURRENT_SOURCE_DIR}/mc/hostfile_bugged1
  ${CMAKE_CURRENT_SOURCE_DIR}/mc/hostfile_bugged2
  PARENT_SCOPE
  )
set(txt_files
  ${txt_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions0.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions1.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_allReduce.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_allgatherv.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_alltoall.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_alltoallv.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_barrier.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_bcast.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_bcast_reduce_datatypes.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_gather.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_reducescatter.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_waitall.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/actions_with_isend.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/replay/split_traces
  PARENT_SCOPE
  )

=== teshsuite/msg/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(EXECUTABLE_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}")

add_executable(get_sender ${CMAKE_HOME_DIRECTORY}/teshsuite/msg/get_sender.c)
add_executable(pid ${CMAKE_HOME_DIRECTORY}/teshsuite/msg/pid.c)

### Add definitions for compile
if(NOT WIN32)
  target_link_libraries(get_sender simgrid)
  target_link_libraries(pid simgrid m pthread)
else()
  target_link_libraries(get_sender simgrid)
  target_link_libraries(pid simgrid)
endif()

set(tesh_files
  ${tesh_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/get_sender.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/pid.tesh
  PARENT_SCOPE
  )
set(xml_files
  ${xml_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/get_sender_d.xml
  ${CMAKE_CURRENT_SOURCE_DIR}/get_sender_p.xml
  ${CMAKE_CURRENT_SOURCE_DIR}/pid_d.xml
  ${CMAKE_CURRENT_SOURCE_DIR}/pid_p.xml
  PARENT_SCOPE
  )
set(teshsuite_src
  ${teshsuite_src}
  ${CMAKE_CURRENT_SOURCE_DIR}/get_sender.c
  ${CMAKE_CURRENT_SOURCE_DIR}/pid.c
  PARENT_SCOPE
  )
set(bin_files
  ${bin_files}
  PARENT_SCOPE
  )
set(txt_files
  ${txt_files}
  PARENT_SCOPE
  )

=== teshsuite/simdag/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(EXECUTABLE_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}")

add_executable(basic0 basic0.c)
add_executable(basic1 basic1.c)
add_executable(basic2 basic2.c)
add_executable(basic3 basic3.c)
add_executable(basic4 basic4.c)
add_executable(basic5 basic5.c)
add_executable(basic6 basic6.c)
add_executable(incomplete incomplete.c)

### Add definitions for compile
if(NOT WIN32)
  target_link_libraries(basic0 simgrid m pthread )
  target_link_libraries(basic1 simgrid m pthread )
  target_link_libraries(basic2 simgrid m pthread )
  target_link_libraries(basic3 simgrid m pthread )
  target_link_libraries(basic4 simgrid m pthread )
  target_link_libraries(basic5 simgrid m pthread )
  target_link_libraries(basic6 simgrid m pthread )
  target_link_libraries(incomplete simgrid m pthread )
else()
  target_link_libraries(basic0 simgrid)
  target_link_libraries(basic1 simgrid)
  target_link_libraries(basic2 simgrid)
  target_link_libraries(basic3 simgrid)
  target_link_libraries(basic4 simgrid)
  target_link_libraries(basic5 simgrid)
  target_link_libraries(basic6 simgrid)
  target_link_libraries(incomplete simgrid)
endif()

set(tesh_files
  ${tesh_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/basic0.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/basic1.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/basic2.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/basic3.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/basic4.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/basic5.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/basic6.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/incomplete.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/simdag.tesh
  PARENT_SCOPE
  )
set(xml_files
  ${xml_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/basic_platform.xml
  PARENT_SCOPE
  )
set(teshsuite_src
  ${teshsuite_src}
  ${CMAKE_CURRENT_SOURCE_DIR}/basic0.c
  ${CMAKE_CURRENT_SOURCE_DIR}/basic1.c
  ${CMAKE_CURRENT_SOURCE_DIR}/basic2.c
  ${CMAKE_CURRENT_SOURCE_DIR}/basic3.c
  ${CMAKE_CURRENT_SOURCE_DIR}/basic4.c
  ${CMAKE_CURRENT_SOURCE_DIR}/basic5.c
  ${CMAKE_CURRENT_SOURCE_DIR}/basic6.c
  ${CMAKE_CURRENT_SOURCE_DIR}/incomplete.c
  PARENT_SCOPE
  )
set(bin_files
  ${bin_files}
  PARENT_SCOPE
  )
set(txt_files
  ${txt_files}
  PARENT_SCOPE
  )

=== teshsuite/simix/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(EXECUTABLE_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}")

add_executable(check_defaults check_defaults.c)
target_link_libraries(check_defaults simgrid)

set(tesh_files
  ${tesh_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/factory_raw.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/factory_thread.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/factory_ucontext.tesh
  PARENT_SCOPE
  )
set(xml_files
  ${xml_files}
  PARENT_SCOPE
  )
set(teshsuite_src
  ${teshsuite_src}
  ${CMAKE_CURRENT_SOURCE_DIR}/check_defaults.c
  PARENT_SCOPE
  )
set(bin_files
  ${bin_files}
  PARENT_SCOPE
  )
set(txt_files
  ${txt_files}
  PARENT_SCOPE
  )

=== teshsuite/smpi/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

if(enable_smpi)
  if(WIN32)
    set(CMAKE_C_FLAGS "-include ${CMAKE_HOME_DIRECTORY}/include/smpi/smpi_main.h")
  else()
    set(CMAKE_C_COMPILER "${CMAKE_BINARY_DIR}/smpi_script/bin/smpicc")
  endif()

  set(EXECUTABLE_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}")

  include_directories("${CMAKE_HOME_DIRECTORY}/include/smpi")
  add_executable(gather_coll gather_coll.c)
  add_executable(allgather_coll allgather_coll.c)
  add_executable(allgatherv_coll allgatherv_coll.c)
  add_executable(alltoall2 alltoall2.c)
  add_executable(alltoall_basic alltoall_basic.c)
  add_executable(alltoall_coll alltoall_coll.c)
  add_executable(alltoallv_coll alltoallv_coll.c)
  add_executable(allreduce allreduce.c)
  add_executable(allreduce_coll allreduce_coll.c)
  add_executable(bcast bcast.c)
  add_executable(bcast_coll bcast_coll.c)
  add_executable(barrier_coll barrier.c )
  add_executable(compute compute.c)
  add_executable(compute2 compute2.c)
  add_executable(compute3 compute3.c)
  add_executable(pingpong pingpong.c)
  add_executable(scatter scatter.c)
  add_executable(reduce reduce.c)
  add_executable(reduce_coll reduce_coll.c)
  add_executable(reduce_scatter_coll reduce_scatter_coll.c)
  add_executable(split split.c)
  add_executable(smpi_sendrecv sendrecv.c)
  add_executable(ttest01 ttest01.c)
  add_executable(vector_test vector_test.c)
  add_executable(hvector_test hvector_test.c)
  add_executable(indexed_test indexed_test.c)
  add_executable(struct_test struct_test.c)
  add_executable(dsend dsend.c)

  target_link_libraries(gather_coll simgrid)
  target_link_libraries(allgather_coll simgrid)
  target_link_libraries(allgatherv_coll simgrid)
  target_link_libraries(alltoall2 simgrid)
  target_link_libraries(alltoall_basic simgrid)
  target_link_libraries(alltoall_coll simgrid)
  target_link_libraries(alltoallv_coll simgrid)
  target_link_libraries(allreduce simgrid)
  target_link_libraries(allreduce_coll simgrid)
  target_link_libraries(bcast simgrid)
  target_link_libraries(bcast_coll simgrid)
  target_link_libraries(barrier_coll simgrid)
  target_link_libraries(compute simgrid)
  target_link_libraries(compute2 simgrid)
  target_link_libraries(compute3 simgrid)
  target_link_libraries(pingpong simgrid)
  target_link_libraries(scatter simgrid)
  target_link_libraries(reduce simgrid)
  target_link_libraries(reduce_coll simgrid)
  target_link_libraries(reduce_scatter_coll simgrid)
  target_link_libraries(split simgrid)
  target_link_libraries(smpi_sendrecv simgrid)
  target_link_libraries(ttest01 simgrid)
  target_link_libraries(vector_test simgrid)
  target_link_libraries(hvector_test simgrid)
  target_link_libraries(indexed_test simgrid)
  target_link_libraries(struct_test simgrid)
  target_link_libraries(dsend simgrid)

  set_target_properties(smpi_sendrecv PROPERTIES RENAME sendrecv)

  if(NOT WIN32)
    add_executable(shared shared.c)
    target_link_libraries(shared simgrid)
  endif()

endif()


set(tesh_files
  ${tesh_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/gather_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/allgather_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/allgatherv_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/allreduce_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/allreduce_coll_large.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/alltoall_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/alltoallv_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/scatter_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/barrier_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/bcast.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/bcast_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/compute.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/shared.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/hvector.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/indexed.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/pt2pt.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/reduce.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/reduce_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/reduce_scatter_coll.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/struct.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/vector.tesh
  ${CMAKE_CURRENT_SOURCE_DIR}/TI_output.tesh
  PARENT_SCOPE
  )
set(xml_files
  ${xml_files}
  PARENT_SCOPE
  )
set(examples_src
  ${examples_src}
  ${CMAKE_CURRENT_SOURCE_DIR}/gather_coll.c
  ${CMAKE_CURRENT_SOURCE_DIR}/allgather_coll.c
  ${CMAKE_CURRENT_SOURCE_DIR}/allgatherv_coll.c
  ${CMAKE_CURRENT_SOURCE_DIR}/allreduce_coll.c
  ${CMAKE_CURRENT_SOURCE_DIR}/alltoall_coll.c
  ${CMAKE_CURRENT_SOURCE_DIR}/alltoallv_coll.c
  ${CMAKE_CURRENT_SOURCE_DIR}/bcast_coll.c
  ${CMAKE_CURRENT_SOURCE_DIR}/reduce_coll.c
  ${CMAKE_CURRENT_SOURCE_DIR}/reduce_scatter_coll.c
  ${CMAKE_CURRENT_SOURCE_DIR}/alltoallv_coll.c
  ${CMAKE_CURRENT_SOURCE_DIR}/get_processor_name.c
  ${CMAKE_CURRENT_SOURCE_DIR}/pingpong.c
  ${CMAKE_CURRENT_SOURCE_DIR}/bcast.c
  ${CMAKE_CURRENT_SOURCE_DIR}/allreduce.c
  ${CMAKE_CURRENT_SOURCE_DIR}/alltoall_basic.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sendrecv.c
  ${CMAKE_CURRENT_SOURCE_DIR}/reduce.c
  ${CMAKE_CURRENT_SOURCE_DIR}/compute2.c
  ${CMAKE_CURRENT_SOURCE_DIR}/shared.c
  ${CMAKE_CURRENT_SOURCE_DIR}/split.c
  ${CMAKE_CURRENT_SOURCE_DIR}/dsend.c
  ${CMAKE_CURRENT_SOURCE_DIR}/ttest01.c
  ${CMAKE_CURRENT_SOURCE_DIR}/compute.c
  ${CMAKE_CURRENT_SOURCE_DIR}/compute3.c
  ${CMAKE_CURRENT_SOURCE_DIR}/alltoall2.c
  ${CMAKE_CURRENT_SOURCE_DIR}/scatter.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sendtest.c
  ${CMAKE_CURRENT_SOURCE_DIR}/barrier.c
  ${CMAKE_CURRENT_SOURCE_DIR}/vector_test.c
  ${CMAKE_CURRENT_SOURCE_DIR}/hvector_test.c
  ${CMAKE_CURRENT_SOURCE_DIR}/indexed_test.c
  ${CMAKE_CURRENT_SOURCE_DIR}/struct_test.c
  PARENT_SCOPE
  )
set(bin_files
  ${bin_files}
  ${CMAKE_CURRENT_SOURCE_DIR}/hostfile
  PARENT_SCOPE
  )
set(txt_files
  ${txt_files}

  PARENT_SCOPE
  )

=== debian/changelog ===
simgrid (3.10-7) unstable; urgency=medium

  * Only build-dep on valgrind on archs that provide it.

 -- Martin Quinson <mquinson@debian.org>  Tue, 28 Jan 2014 23:36:00 +0100

simgrid (3.10-6) unstable; urgency=low

  * Build-depends on valgrind so that SimGrid programs become
    valgrindable (Closes: #735749).

 -- Martin Quinson <mquinson@debian.org>  Sat, 18 Jan 2014 20:42:39 +0100

simgrid (3.10-5) unstable; urgency=medium

  * Disable parallel builds, as gfortran breaks when building mpich3
    tests in parallel.

 -- Martin Quinson <mquinson@debian.org>  Sat, 11 Jan 2014 22:46:35 +0100

simgrid (3.10-4) unstable; urgency=low

  * Put me as a maintainer and Lucas as an uploader.
  * Get all the new packages conflicting with the old all-in-one
    package (Closes: #734834, #734835).

 -- Martin Quinson <mquinson@debian.org>  Sat, 11 Jan 2014 16:19:55 +0100

simgrid (3.10-2) unstable; urgency=medium

  * Split package in four components: binaries, doc, headers, java.
  * Enable parallel build if the option is set in DEB_BUILD_OPTIONS
  * Rename graphicator to simgrid-graphicator to preserve the namespace
  * d/control: Bump standard version to 3.9.5 (no other change)
  * Upload to unstable now that the package is reasonably clean.

 -- Martin Quinson <mquinson@debian.org>  Sun, 05 Jan 2014 10:12:15 +0100

simgrid (3.10-1) experimental; urgency=low

  * Packaging the final version of the 3.10 release
  * Adapt to the recent versions of cmake:
    - Change -Dprefix into -DCMAKE_INSTALL_PREFIX
    - Don't use -Dcustom_flags but set the environment

 -- Martin Quinson <mquinson@debian.org>  Sun, 24 Nov 2013 15:41:30 +0100

simgrid (3.10~rc2-1) experimental; urgency=low

  * New upstream snapshot, preparing the next 3.10 release.
    - (Hopefully) Fix java building on kfreebsd
    - Adapt to cmake 2.8.12 (Jar dependencies madness)

 -- Martin Quinson <mquinson@debian.org>  Sat, 09 Nov 2013 12:40:00 +0100

simgrid (3.9.90-3) experimental; urgency=low

  * Add gfortran to the build-depends for all SMPI tests (bummer)
  * Add default-jdk to the build-depends for Java (painful)

 -- Martin Quinson <mquinson@debian.org>  Sat, 02 Nov 2013 23:33:03 +0100

simgrid (3.9.90-2) experimental; urgency=low

  * Enable the Java bindings.
  * Enable the full test suite of SMPI features.

 -- Martin Quinson <mquinson@debian.org>  Sat, 02 Nov 2013 20:14:28 +0100

simgrid (3.9.90-1) experimental; urgency=low

  * New upstream snapshot, to prepare the 3.10 release.

 -- Lucas Nussbaum <lucas@debian.org>  Thu, 24 Oct 2013 13:31:29 +0200

=== debian/control ===
Source: simgrid
Section: science
Priority: extra
Maintainer: Martin Quinson <mquinson@debian.org>
Uploaders: Lucas Nussbaum <lucas@debian.org>
Build-Depends: debhelper (>= 7.0.50~), cmake, liblua5.1-dev, lua5.1,
 f2c, chrpath, libpcre3-dev, default-jdk, gfortran,
 valgrind [amd64 armhf i386 mips mipsel mips64 mips64el powerpc ppc64 s390x x32],
Standards-Version: 3.9.5
Homepage: http://simgrid.gforge.inria.fr/
Vcs-Git: git://git.debian.org/git/collab-maint/simgrid.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/simgrid.git

Package: libsimgrid3.10
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: lua5.1
Conflicts: simgrid (<< 3.10)
Description: Toolkit for scalable simulation of distributed applications
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains the dynamic libraries and runtime.

Package: simgrid-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Conflicts: simgrid (<< 3.10)
Description: Toolkit for scalable simulation of distributed applications
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains the documentation for both the C and the Java
 version of SimGrid.

Package: simgrid-java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libsimgrid3.10 (>= ${source:Version})
Recommends: simgrid-doc (>= ${source:Version})
Conflicts: simgrid (<< 3.10)
Description: Toolkit for scalable simulation of distributed applications
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains all what you need to use SimGrid from the Java
 programming language. Note that the jarfile contained in this package
 will only work on the architecture it is compiled for (as opposed to
 the jarfile proposed on the project web page that should work on all
 architecture).

Package: libsimgrid-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, 
  libsimgrid3.10 (= ${binary:Version})
Recommends: f2c, gcc, make, simgrid-doc (>= ${source:Version})
Conflicts: simgrid
Replaces: simgrid
Provides: simgrid
Description: Toolkit for scalable simulation of distributed applications
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains the development files that you need to build
 your own simulator on top of SimGrid (header files and helping scripts).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Package building rules for the SimGrid Debian Package.
# Strongly inspirated from the sample debhelper file, originally written by Joey Hess and Craig Small.
# Adapted to SimGrid by Lucas Nussbaum and Martin Quinson.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS += $(shell dpkg-buildflags --get CFLAGS)
# build with -O3 everywhere except on ia64 (#640538) since it is upstream
# policy to do so.
ifneq (ia64,$(shell dpkg-architecture -qDEB_HOST_ARCH))
  CFLAGS += -O3
endif

ifeq (arm,$(shell dpkg-architecture -qDEB_HOST_GNU_CPU))
  CFLAGS += -funwind-tables
endif

LDFLAGS += $(shell dpkg-buildflags --get LDFLAGS)

# parallel build does not work with gfortran building mpich3 tests

%:
	dh  $@ # --parallel

# CMAKE_BUILD_TYPE= (unset CMAKE_BUILD_TYPE) required, because:
# - dh magic runs cmake with -DCMAKE_BUILD_TYPE=RelWithDebInfo
# - this adds -DNDEBUG to CFLAGS (maybe a bug, see #711515)
# - this breaks simgrid (or at least some tests).
override_dh_auto_configure:
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	  dh_auto_configure -Scmake -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE= \
		-Denable_smpi_MPICH3_testsuite=ON \
		-Denable_java=ON \
		-Denable_print_message=ON
		
# FIXME renable tests at some point
override_dh_auto_test:
	dh_auto_test || true

override_dh_auto_install:
	dh_auto_install --fail-missing
	chrpath -d debian/tmp/usr/bin/graphicator
	chrpath -d debian/tmp/usr/bin/tesh
	mv debian/tmp/usr/bin/graphicator debian/tmp/usr/bin/simgrid-graphicator
	# move doc to correct place
	mkdir -p debian/tmp/usr/share/doc/simgrid
	mv debian/tmp/usr/doc/simgrid/* debian/tmp/usr/share/doc/simgrid/
	rm -rf debian/tmp/usr/doc
	# move jarfile to the right location
	mkdir -p debian/tmp/usr/share/java
	mv debian/tmp/usr/java/simgrid.jar debian/tmp/usr/share/java
	rm -rf debian/tmp/usr/java
